-- Locks

locked_door = obj {
    var {
        room = nil,
    },
    nam = "Закрытая дверь",
    dsc = function (s,w)
        p([[^{Дверь} ]]..s.room.where..[[ закрыта на ключ.]])
    end,
    act = function (s,w)
        p[[Нужен ключ, чтобы ее открыть.]]
    end,
    used = function(s,w)
        if w == silver_key then
            p("Я вставил серебряный ключ в замок и повернул его. Раздался щелчок, и дверь открылась.")
            unlock_room(s.room,s,w)
        elseif w == axe then
            if check_strength() then
                p([[Я размахнулся и ударил топором по двери. Щепки полетели в разные стороны. Мне удалось попасть в замок,
                  и дверь, жалобно скрипнув, приоткрылась.]])
                unlock_room(s.room,s)
            else
                rprint({
                [[Я размахнулся и попытался ударить топором по двери. К сожалению, я промахнулся, и топор вонзился в пол.]],
                [[Я выхватил топор и ударил им по двери. Увы, моих сил не хватило на то, чтобы хоть как-то повредить дверь.]]
                })
            end
            incr_action()
        end
    end
}

magical_lock = obj {
    var {
        room = nil,
    },
    nam = "Магический замок",
    dsc = function (s,w)
        p([[^На {двери} ]]..s.room.where..[[ нарисованы какие-то руны.]])
    end,
    act = function (s,w)
        p[[Похоже, что дверь можно открыть с помощью какого-то заклинания.]]
    end,
    used = function(s,w)
        if w == magic_phrase then
            p([[Я достал листок с заклинанием и громко прочел его. Сначала ничего не происходило, но затем руны на двери
              вспыхнули ярким светом и пропали. Похоже, мне удалось открыть дверь.]])
            unlock_room(s.room,s,w)
        elseif w == axe then
            if check_strength() then
                p([[Я размахнулся и несколько раз что есть силы ударил топором по двери. Через некоторое время в двери
                  образовался пролом, войти через который не составит никакого труда.]])
                unlock_room(s.room,s)
            else
                rprint({
                [[Я размахнулся и попытался ударить топором по двери. К сожалению, я промахнулся, и топор вонзился в пол.]],
                [[Я выхватил топор и ударил им по двери. Увы, моих сил не хватило на то, чтобы хоть как-то повредить дверь.]]
                })
            end
            incr_action()
        end
    end
}

jammed_door = obj {
    var {
        room = nil,
    },
    nam = "Заклинившая дверь",
    dsc = function (s,w)
        p([[^{Дверь} ]]..s.room.where..[[ заклинило.]])
    end,
    act = function (s,w)
        if check_strength() then
            p[[Я навалился всем телом на дверь, пытаясь ее открыть. Но мне удалось приоткрыть ее настолько, чтобы я смог пройти.]]
            unlock_room(s.room,s)
        else
            p[[Я со всей силы навалился на дверь. Бесполезно - она не сдвинулась даже на миллиметр.]]
        end
        incr_action()
    end,
    used = function(s,w)
        if w == axe then
            if check_strength() then
                p([[Я вставил топор в дверную щель и, действуя им как рычагом, приоткрыл дверь. Похоже, теперь я смогу пролезть.]])
                unlock_room(s.room,s)
            else
                rprint({
                [[Вставив топор в дверную щель, я что есть сил налег на него, пытаясь открыть дверь. Безрезультатно.]],
                [[Я вставил топор в дверную щель и попытался открыть дверь, действуя топором как рычагом. Увы, моих сил не хватило,
                чтобы приоткрыть дверь хоть на миллиметр.]]
                })
            end
            incr_action()
        end
    end
}